#ifndef HARKTOOL4_TEMPLATEMAKER_HPP
#define HARKTOOL4_TEMPLATEMAKER_HPP

#include <memory>
#include <ostream>
#include <boost/program_options.hpp>

/** @file
 * TemplateMaker クラスの定義
 */

namespace harktool4
{

/** @brief HARK-configファイルのテンプレートを生成する機能を提供するクラス。
 */
class TemplateMaker
{
public:
    TemplateMaker(const boost::program_options::variables_map& vm, std::shared_ptr<std::ostream> output_file);
    TemplateMaker(const TemplateMaker& rhs) = delete;
    TemplateMaker& operator =(const TemplateMaker&) = delete;
    void Run();
private:
    class Impl;
    std::shared_ptr<Impl> impl_;
};

}

#endif // HARKTOOL4_TEMPLATEMAKER_HPP

